#include <iostream>
#include <vector>
#include <algorithm>
#define FOR(i,a,b) for(int i = (a); i < (b); i++)
using namespace std;

struct CHILD{
	CHILD(int id):depth(0),id(id){}
	int depth;
	int id;
	bool operator <(const CHILD& a)const{
		return depth > a.depth;
	}
};

struct NODE{
	vector<CHILD> children;
	int deepestChild;
};

vector<NODE> nodes;
int n;

int rec(int vId) {
	vector<CHILD> & v = nodes[vId].children;
	if(v.empty()) {
		nodes[vId].deepestChild = vId;
		return 1;
	}
	int maxDepth = 0;
	for(vector<CHILD>::iterator it = v.begin(); it != v.end(); ++it) {
		int depth = rec(it -> id);
		it -> depth = depth;
		if(depth > maxDepth) {
			maxDepth = depth;
			nodes[vId].deepestChild = nodes[it -> id].deepestChild;
		}
	}
	sort(v.begin(), v.end());
	return maxDepth + 1;
}

int nextV(int vId, int * arr) {
	int max = 0;
	int bestV = vId;
	int i = 0;
	while(arr[vId] != -1) {
		i++;
		int par = arr[vId];
		int value = i;
		if(nodes[par].children[0].id == vId) {
			if(nodes[par].children.size() != 1) value += nodes[par].children[1].depth;
		}
		else value += nodes[par].children[0].depth;
		if(max < value){
			max = value;
			bestV = par;
		}
		vId = par;
		
	}
	return bestV;;
}

void deleteNode(int vId, int * arr) {
	if(arr[vId == -1) return;
	int par = arr[vId];
	vector<CHILDREN> & parChildren = nodes[par].children;
	parChildren.erase(parChildren.begin());
	while(arr[vId] != -1) {
		sort(nodes[par].children.begin(), nodes[par].children.end());
		nodes[par].
	}
}

int main(){
	while(cin >> n){
		int arr[n];
		//int arr1[n];
		arr[0] = -1;

		FOR(i, 1, n) {
			cin >> arr[i];
			//arr1[i] = arr[i];
		}
		nodes.clear();
		FOR(i, 0, n) nodes.push_back(NODE());
		FOR(i, 1, n) nodes[arr[i]].children.push_back(CHILD(i));
		rec(0);
		int currV = nodes[0].deepestChild;
		FOR(i,0, n) {
			int nv = nextV(currV, arr);
			arr[currV] = -1;
			
		}
	}
	return 0;
}
